Package: org.codehaus.groovy.runtime

## [Java] Class DefaultGroovyStaticMethods

- org.codehaus.groovy.runtime.DefaultGroovyStaticMethods

- This class defines all the new static groovy methods which appear on normal JDK classes inside the Groovy environment. Static methods are used with the first parameter as the destination class.

  Authors:
    Guillaume Laforge
    Dierk Koenig
    Joachim Baumann
    Paul King
    Kent Inge Fagerland Simonsen

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `static File` | `createTempDir(File self)`
    `` | `static File` | `createTempDir(File self, String prefix, String suffix)`
    `` | `static long` | `currentTimeSeconds(System self)` Get the current time in seconds
    `` | `static ResourceBundle` | `getBundle(ResourceBundle self, String bundleName)` Works exactly like ResourceBundle.getBundle(String).
    `` | `static ResourceBundle` | `getBundle(ResourceBundle self, String bundleName, Locale locale)` Works exactly like ResourceBundle.getBundle(String, Locale).
    `` | `static Matcher` | `getLastMatcher(Matcher self)` Get the last hidden matcher that the system used to do a match.
    `` | `static Date` | `parse(Date self, String format, String input)` Parse a String into a Date instance using the given pattern.
    `` | `static Date` | `parse(Date self, String format, String input, TimeZone zone)` Parse a String into a Date instance using the given pattern and TimeZone.
    `` | `static Date` | `parseToStringDate(Date self, String dateToString)` Parse a String matching the pattern EEE MMM dd HH:mm:ss zzz yyyy containing US-locale-constants only (e.g.
    `` | `static void` | `sleep(Object self, long milliseconds)` Sleep for so many milliseconds, even if interrupted.
    `` | `static void` | `sleep(Object self, long milliseconds, Closure onInterrupt)` Sleep for so many milliseconds, using a given closure for interrupt processing.
    `` | `static Thread` | `start(Thread self, Closure closure)` Start a Thread with the given closure as a Runnable instance.
    `` | `static Thread` | `start(Thread self, String name, Closure closure)` Start a Thread with a given name and the given closure as a Runnable instance.
    `` | `static Thread` | `startDaemon(Thread self, Closure closure)` Start a daemon Thread with the given closure as a Runnable instance.
    `` | `static Thread` | `startDaemon(Thread self, String name, Closure closure)` Start a daemon Thread with a given name and the given closure as a Runnable instance.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, toString, hashCode, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### public static File createTempDir(File self)

    - #### public static File createTempDir(File self, String prefix, String suffix)

    - #### public static long currentTimeSeconds(System self)

      Get the current time in seconds

      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
      Returns:
        the difference, measured in seconds, between the current time and midnight, January 1, 1970 UTC.
      See Also:
        System.currentTimeMillis

    - #### public static ResourceBundle getBundle(ResourceBundle self, String bundleName)

      Works exactly like ResourceBundle.getBundle(String). This is needed because the java method depends on a particular stack configuration that is not guaranteed in Groovy when calling the Java method.

      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `bundleName` - the name of the bundle.
      Returns:
        the resource bundle
      See Also:
        ResourceBundle.getBundle
      Since:
        1.6.0

    - #### public static ResourceBundle getBundle(ResourceBundle self, String bundleName, Locale locale)

      Works exactly like ResourceBundle.getBundle(String, Locale). This is needed because the java method depends on a particular stack configuration that is not guaranteed in Groovy when calling the Java method.

      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `bundleName` - the name of the bundle.
        `locale` - the specific locale
      Returns:
        the resource bundle
      See Also:
        ResourceBundle.getBundle
      Since:
        1.6.0

    - #### public static Matcher getLastMatcher(Matcher self)

      Get the last hidden matcher that the system used to do a match.

      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
      Returns:
        the last regex matcher
      Since:
        1.0

    - #### public static Date parse(Date self, String format, String input)

      Parse a String into a Date instance using the given pattern. This convenience method acts as a wrapper for SimpleDateFormat.

      Note that a new SimpleDateFormat instance is created for every invocation of this method (for thread safety).

      throws:
        ParseException if there is a parse error
      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `format` - pattern used to parse the input string.
        `input` - String to be parsed to create the date instance
      Returns:
        a new Date instance representing the parsed input string
      See Also:
        SimpleDateFormat.parse
      Since:
        1.5.7

    - #### public static Date parse(Date self, String format, String input, TimeZone zone)

      Parse a String into a Date instance using the given pattern and TimeZone. This convenience method acts as a wrapper for SimpleDateFormat.

      Note that a new SimpleDateFormat instance is created for every invocation of this method (for thread safety).

      throws:
        ParseException if there is a parse error
      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `format` - pattern used to parse the input string.
        `input` - String to be parsed to create the date instance
        `zone` - TimeZone to use when parsing
      Returns:
        a new Date instance representing the parsed input string
      See Also:
        SimpleDateFormat.parse
      Since:
        2.4.1

    - #### public static Date parseToStringDate(Date self, String dateToString)

      Parse a String matching the pattern EEE MMM dd HH:mm:ss zzz yyyy containing US-locale-constants only (e.g. Sat for Saturdays). Such a string is generated by the toString method of Date

      Note that a new SimpleDateFormat instance is created for every invocation of this method (for thread safety).

      throws:
        ParseException if there is a parse error
      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `dateToString` - String to be parsed to create the date instance. Must match the pattern EEE MMM dd HH:mm:ss zzz yyyy with US-locale symbols
      Returns:
        a new Date instance representing the parsed input string

    - #### public static void sleep(Object self, long milliseconds)

      Sleep for so many milliseconds, even if interrupted.

      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `milliseconds` - the number of milliseconds to sleep
      Since:
        1.0

    - #### public static void sleep(Object self, long milliseconds, Closure onInterrupt)

      Sleep for so many milliseconds, using a given closure for interrupt processing.

      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `milliseconds` - the number of milliseconds to sleep
        `onInterrupt` - interrupt handler, InterruptedException is passed to the Closure as long as it returns false, the sleep continues
      Since:
        1.0

    - #### public static Thread start(Thread self, Closure closure)

      Start a Thread with the given closure as a Runnable instance.

      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `closure` - the Runnable closure
      Returns:
        the started thread
      Since:
        1.0

    - #### public static Thread start(Thread self, String name, Closure closure)

      Start a Thread with a given name and the given closure as a Runnable instance.

      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `name` - the name to give the thread
        `closure` - the Runnable closure
      Returns:
        the started thread
      Since:
        1.6

    - #### public static Thread startDaemon(Thread self, Closure closure)

      Start a daemon Thread with the given closure as a Runnable instance.

      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `closure` - the Runnable closure
      Returns:
        the started thread
      Since:
        1.0

    - #### public static Thread startDaemon(Thread self, String name, Closure closure)

      Start a daemon Thread with a given name and the given closure as a Runnable instance.

      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `name` - the name to give the thread
        `closure` - the Runnable closure
      Returns:
        the started thread
      Since:
        1.6